//ensemble de Mandelbrot en 320*200, criture directe en VRAM
//basculement Madelbrot-Julia
//calculs en entrelac, permet d'interrompre un calcul pour faire un zoom
//zoom in, out et box
//gestion de la souris
//02/97
#include <conio.h>
#include <dos.h> //pr emit et outportb
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define VRAI 1
#define FAUX 0
#define PI 3.1415926535

typedef unsigned long dword;
typedef unsigned int word;
typedef unsigned char byte;

void Init();
void putpixel(word x,word y,word c);
word getpixel(word x,word y);
void clrscr();
void setpalette(int offset);
void closegraph();
int sqr(int in){return(in*in);}
int min(int x,int y){return (x<y?x:y);}
int max(int x,int y){return (x<y?y:x);}

void mouse_win(int minx,int miny,int maxx,int maxy);
void mouse_curs(int curseur);
word mouse_bout();
void mouse_pos(word *sourx,word *soury);
void mouse_set(word x,word y);
word mouse_test();

int maxcoul,maxcoul2,mousepres,isjulia=FAUX;


class Point
{
private:
	double BordEcr[4];
	double x,y,xref,yref;
public:
	Point(double G,double H,double D,double B);
	void ChangeBords(int G,int H,int D,int B);
	void PrintBords();
	void SetJuliaRef(int xe,int ye);
	void PInit(double xlog,double ylog);
	void PInitE(int xe,int ye);
	int PTeste();
};

void main(void)
{
	double H=2.,B=-2.,G=-4.,D=1.;
	int res,effacer=FAUX;
	printf("\n\nZoom:\n\
Flches ou souris: dplacement du curseur\n\
<->: zoom out (2*) centr sur le curseur\n\
<+>: zoom in (2*) centr sur le curseur\n\
<Entre> ou bouton souris: slection d'une bote de zoom box\n\
<Espace>: basculer du Mandelbrot au Julia\n\
<0>: effacer ou non l'cran avant de redessiner\n\
<Esc>: quitter\n\n\n\
Appuyez sur une touche pour continuer...");
	getch();

	Point p(G,H,D,B);
	Init();
	mousepres=mouse_test();
	mouse_curs(0);  //initialisation curseur
	mouse_win(0,0,318,198);
	do{
		int xecr,yecr,coul=0,incr=16;//,nvcoul=0;
		for(xecr=0;incr>1&&!kbhit()&&!mouse_bout();xecr+=incr){
			//gestion du caractre entrelac de l'image calcule:
			if(xecr>=320){
				if(incr==16&&!(xecr&0x08))xecr=-8;
				else{
					incr>>=1;
					xecr=-(incr>>1);
				}
			}
			else{
				for(yecr=0;yecr<200;yecr++){
					//pour chaque point, calcul de la couleur correspondante:
					p.PInitE(xecr,yecr);
					coul=p.PTeste();
					putpixel(xecr,yecr,coul);
				}
			}
		}
		word cursx=160,cursy=100,x1,y1;//curstmpx,curstmpy;
		do{}while(mouse_bout());	//attendre que l'ventuel bouton soit relach
		char c;
		mouse_set(160,100);
		mouse_curs(1);
		int nbcoinssel=0;
		do{
			res=0;      //0: acquisition (clavier ou souris) demande
							//1: doit redessiner				2:quitter
			c='\x1';
			do{
				if(kbhit())c=getch();
				if(mouse_bout()){
					c='\r';
					do{}while(mouse_bout());
				}
			}while(c=='\x1');
			mouse_pos(&cursx,&cursy);
			switch(c){
				case '\0':
					c=getch();
					switch(c){
						case 'H':
							if(cursy>2)cursy-=2;
							break;
						case 'P':
							if(cursy<198)cursy+=2;
							break;
						case 'K':
							if(cursx>2)cursx-=2;
							break;
						case 'M':
							if(cursx<318)cursx+=2;
					}
					break;
				case '-':
					p.ChangeBords(-160+((int)cursx-160),-100+((int)cursy-100),480+((int)cursx-160),300+((int)cursy-100));
					res=1;
					break;
				case '+':
					p.ChangeBords(80+((int)cursx-160),50+((int)cursy-100),240+((int)cursx-160),150+((int)cursy-100));
					res=1;
					break;
				case '\r':
					if(!nbcoinssel){x1=cursx; y1=cursy; nbcoinssel++;}
					else if(x1!=cursx&&y1!=cursy){
						p.ChangeBords(min(x1,cursx),min(y1,cursy),
										  max(x1,cursx),max(y1,cursy));
						res=1;
					}
					break;
				case ' ':
					isjulia=!isjulia;
					p.SetJuliaRef(cursx,cursy);
					res=1;
					break;
				case '0':
					effacer=!effacer;
					break;
				case '\x1B':
					res=2;
			}
			mouse_set(cursx,cursy);
		}while(res==0);
		mouse_curs(2);
		if(effacer)clrscr();
	}while(res!=2);
	closegraph();
	p.PrintBords();
}

void Init()
{
	__emit__(0xb8,0x13,0x00,0xcd,0x10); //320*200*256
	maxcoul=256;//getmaxcolor();
	maxcoul2=maxcoul/2;		//acclre les calculs
	setpalette(0);
	randomize();
}

void closegraph()
{	__emit__(0xb8,0x03,0x00,0xcd,0x10); //retour au mode texte
}

void setpalette(int offset)
{
	byte r,g,b;
	for(int i=0;i<256;i++){
		r=63/(sqr((i+214)%256-128)/5000.+1.);
		g=63/(sqr((i+129)%256-128)/5000.+1.);
		b=63/(sqr((i+44)%256-128)/5000.+1.);
		outportb(0x3c8,i+offset);
		outportb(0x3c9,r);
		outportb(0x3c9,g);
		outportb(0x3c9,b);
	}
	outportb(0x3c8,offset);
	outportb(0x3c9,0);
	outportb(0x3c9,0);
	outportb(0x3c9,0);
}

void putpixel(word x,word y,word c)
{ 	char far *Screen;
	Screen=(char far *)MK_FP(0xa000,0x0000);
	Screen[(dword)y*320ul+(dword)x]=(byte)c;
}

void clrscr()
{ 	char far *Screen;
	Screen=(char far *)MK_FP(0xa000,0x0000);
	dword i;
	for(i=0;i<64000;i++)Screen[i]=(byte)0;
}

word getpixel(word x,word y)
{ 	char far *Screen;
	Screen=(char far *)MK_FP(0xa000,0x0000);
	return((word)Screen[(dword)y*320ul+(dword)x]);
}

Point::Point(double G,double H,double D,double B)
{ 	BordEcr[0]=H;	BordEcr[1]=G;
	BordEcr[2]=B;	BordEcr[3]=D;
}

void Point::ChangeBords(int G,int H,int D,int B)
{ 	double tmp[4];
	tmp[0]=BordEcr[0]+H/200.*(BordEcr[2]-BordEcr[0]);
	tmp[1]=BordEcr[1]+G/320.*(BordEcr[3]-BordEcr[1]);
	tmp[2]=BordEcr[0]+B/200.*(BordEcr[2]-BordEcr[0]);
	tmp[3]=BordEcr[1]+D/320.*(BordEcr[3]-BordEcr[1]);
	for(int i=0;i<4;i++)BordEcr[i]=tmp[i];
}

void Point::PrintBords()
{	printf("Coordonnes des bords de la fentre actuelle:\n\
Gauche:  %g\n\
Haut:    %g\n\
Droite:  %g\n\
Bas:     %g\n",BordEcr[1],BordEcr[0],BordEcr[3],BordEcr[2]);
	FILE *f;
   f=fopen("coord.dbl","wb");
   fwrite(BordEcr,8,4,f);
   fclose(f);
   printf("Donnes enregistres dans le fichier coord.dbl");
}

void Point::SetJuliaRef(int xe,int ye)
{	xref=BordEcr[1]+xe/320.*(BordEcr[3]-BordEcr[1]);
	yref=BordEcr[0]+ye/200.*(BordEcr[2]-BordEcr[0]);
}

void Point::PInit(double xlog,double ylog)
{	x=xlog;		y=ylog;
	if(!isjulia){xref=x; yref=y;}   //voir PInitE()
}

void Point::PInitE(int xe,int ye)
{	x=BordEcr[1]+xe/320.*(BordEcr[3]-BordEcr[1]);
	y=BordEcr[0]+ye/200.*(BordEcr[2]-BordEcr[0]);
	if(!isjulia){xref=x; yref=y;}	/*le Mandelbrot est considr comme un
	Julia qui en chaque point a ce point comme point de rfrence*/
}

int Point::PTeste()
{ 	double xtmp,ytmp,re,im,taillemax=100.;
	int maxiter=256,i;
	xtmp=x;	ytmp=y;
	for(i=0;i<maxiter;i++){
		re=xtmp*xtmp;	im=ytmp*ytmp;
		if(re+im>taillemax)break;
		ytmp=(xtmp*ytmp)+yref;
		xtmp=(re-im)/2+xref;
	}
	return (int)(i);
}

//Fonctions de gestion de la souris:
//attention: elles ont t modifies prr tenir compte du doublement de
//l'chelle des x
void mouse_win(int minx,int miny,int maxx,int maxy)
{ 	minx<<=1;	maxx<<=1;
	if(mousepres)asm{
		mov ax,07h
		mov cx,minx
		mov dx,maxx
		int 33h
		mov ax,08h
		mov cx,miny
		mov dx,maxy
		int 33h
	}
}

void mouse_curs(int curseur)
{ 	if(mousepres&&curseur>=0&&curseur<=2)
	asm{        //0: init  1: montre  2:cache
		mov ax,curseur
		int 33h
	}
}

word mouse_bout()
{ 	if(!mousepres)return 0;
	word retvalue;
	asm{
		mov ax,03h
		int 33h
		mov retvalue,bx
	}
	return retvalue;
}

void mouse_pos(word *sourx,word *soury)
{ 	word retx,rety;
	if(mousepres)asm{
		mov ax,03h
		int 33h
		mov retx,cx
		mov rety,dx
	}
	*sourx=retx>>1;
	*soury=rety;
}

void mouse_set(word x,word y)
{ 	x<<=1;
	if(mousepres)asm{
		mov ax,4
		mov cx,x
		mov dx,y
		int 33h
	}
}

word mouse_test()
{ 	asm{
		mov AH,00h
		int 33h
	}
	return(_AX);	//1:OK 0: pas de souris
}
